
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <SDL/SDL.h>
#include "../screen.h"
#include "../video.h"

SDL_bool
effect_scanline_init() 
{
	return SDL_TRUE;
}

void 
effect_scanline_update()
{
	Uint16 *src, *dst;
	Uint32 s, d;
	Uint8 h, w;	
	
	(Uint16 *)src = (Uint16 *)buffer->pixels + 16 + (336 << 4);// LeftBorder + RowLength * UpperBorder
	(Uint16 *)dst = (Uint16 *)screen->pixels;

	for(h = 224; h > 0; h--)
	{
		for(w = 152; w > 0; w--)
		{		
			s = *(Uint32 *)src;
#ifdef WORDS_BIGENDIAN
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst) = d;			
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst+2) = d;		
#else
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst+2) = d;			
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst) = d;			
#endif
			
			dst += 4;
			src += 2;
		}
		src += 32;		
		dst += 608;
	}
}

void 
effect_scanline50_update()
{
	Uint16 *src, *dst;
	Uint32 s, d;
	Uint8 h, w;
	
	(Uint16 *)src = (Uint16 *)buffer->pixels + 16 + (336 << 4);// LeftBorder + RowLength * UpperBorder
	(Uint16 *)dst = (Uint16 *)screen->pixels;

	
	for(h = 224; h > 0; h--)
	{
		for(w = 152; w > 0; w--)
		{		
			s = *(Uint32 *)src;
#ifdef WORDS_BIGENDIAN
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst) = d;
			*(Uint32 *)(dst+608) = (d & 0xf7def7de) >> 1;
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst+2) = d;
			*(Uint32 *)(dst+610) = (d & 0xf7def7de) >> 1;
#else				
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst+2) = d;
			*(Uint32 *)(dst+610) = (d & 0xf7def7de) >> 1;
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst) = d;
			*(Uint32 *)(dst+608) = (d & 0xf7def7de) >> 1;			
#endif			
			dst += 4;
			src += 2;
		}
		src += 32;		
		dst += 608;
	}
}
void 

effect_doublex_update()
{
	Uint16 *src, *dst;
	Uint32 s, d;
	Uint8 h, w;	
	
	(Uint16 *)src = (Uint16 *)buffer->pixels + 16 + (336 << 4);// LeftBorder + RowLength * UpperBorder
	(Uint16 *)dst = (Uint16 *)screen->pixels;

#if I386_ASM
	do_inner_doublex_i386(dst,src,screen->pitch);
#else

	for(h = 224; h > 0; h--)
	{
		for(w = 152; w > 0; w--)
		{		
			s = *(Uint32 *)src;
#ifdef WORDS_BIGENDIAN
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst) = d;			
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst+2) = d;		
#else
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst+2) = d;			
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst) = d;			
#endif
			
			dst += 4;
			src += 2;
		}
		src += 32;		
		//dst += 608;
	}
#endif
}
